#! /bin/sh

INTERFACE="eth0"

if [ ! -z $1 ]
then
	INTERFACE=$1
fi

HOSTNAME=$(cat /etc/hostname)

IP=$(/sbin/ifconfig $INTERFACE | grep "inet " | awk '{print $2}' | cut -d: -f2)
NETMASK=$(/sbin/ifconfig $INTERFACE | grep "inet " | awk '{print $4}' | cut -d: -f2)
GATEWAY=""

if [ -z $IP ]
then
	IP=$(/sbin/ifconfig $INTERFACE:avahi | grep "inet " | awk '{print $2}' | cut -d: -f2)
	NETMASK=$(/sbin/ifconfig $INTERFACE:avahi | grep "inet " | awk '{print $4}' | cut -d: -f2)
fi

PROTO=$(grep inet /etc/network/ifcfg-$INTERFACE | cut -d' ' -f4)

if [ "$PROTO" == "static" ]
then
        GATEWAY=$(grep gateway /etc/network/ifcfg-$INTERFACE | awk '{print $2}')
fi

echo "$HOSTNAME|$PROTO|$IP|$NETMASK|$GATEWAY"
