#! /bin/sh

if [ ! $# -eq 2 ]; then
	echo "usage installDisk.sh <disk device | image-file-name> <rootfs.tar>"
	exit
fi

if [ $(whoami) != "root" ]; then
	echo "must be called as root, please use 'sudo ..'"
	exit
fi 

edit_grub_cfg () { 
	echo "edit_grub_cfg() $1"

	local GRUBCFG=$1
	
	local PARTUUID3="$( get_partuuid ${DEVICE}3 )"
	local PARTUUID4="$( get_partuuid ${DEVICE}4 )"
	local PARTUUID5="$( get_partuuid ${DEVICE}5 )"

	touch $GRUBCFG

	echo ""																									>> $GRUBCFG
	echo "set GRUBENV=\"/EFI/BOOT/grubenv\""																>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "if [ -f \${GRUBENV} ]; then"																		>> $GRUBCFG
	echo "	load_env --file \${GRUBENV}"																	>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "	if [ \${DEFAULT} != 0 ]; then"																	>> $GRUBCFG
	echo "		if [ \${SWAP} = 1 ]; then"																	>> $GRUBCFG
	echo "			set DEFAULT_BAK=\"0\""																	>> $GRUBCFG
	echo "			set EOS_BAK=\"0\""																		>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "			if [ \${EOS} = 1 ]; then"																>> $GRUBCFG
	echo "				set EOS_BAK=\"1\""																	>> $GRUBCFG
	echo "				if [ \${DEFAULT} = 1 ]; then"														>> $GRUBCFG
	echo "					set DEFAULT_BAK=\"2\""															>> $GRUBCFG
	echo "				elif [ \${DEFAULT} = 2 ]; then"														>> $GRUBCFG
	echo "					set DEFAULT_BAK=\"1\""															>> $GRUBCFG
	echo "				fi"																					>> $GRUBCFG
	echo "			fi"																						>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "			save_env --file \${GRUBENV} DEFAULT_BAK"												>> $GRUBCFG 
	echo "			save_env --file \${GRUBENV} EOS_BAK"													>> $GRUBCFG 
	echo "		fi"																							>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "		if [ \${BC} = 0 ]; then"																	>> $GRUBCFG
	echo "			set BC=\"1\""																			>> $GRUBCFG
	echo "		elif [ \${BC} = 1 ]; then"																	>> $GRUBCFG
	echo "			set BC=\"2\""																			>> $GRUBCFG
	echo "		elif [ \${BC} = 2 ]; then"																	>> $GRUBCFG
	echo "			set BC=\"3\""																			>> $GRUBCFG
	echo "		else"																						>> $GRUBCFG
	echo "			set BC=\"0\""																			>> $GRUBCFG
	echo "			set DEFAULT=\"0\""																		>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "			if [ \${EOS_BAK} = 1 ]; then"															>> $GRUBCFG
	echo "				set DEFAULT=\"\${DEFAULT_BAK}\""													>> $GRUBCFG
	echo "			fi"																						>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "			set DEFAULT_BAK=\"0\""																	>> $GRUBCFG
	echo "			save_env --file \${GRUBENV} DEFAULT_BAK"												>> $GRUBCFG 
	echo "			set EOS_BAK=\"0\""																		>> $GRUBCFG
	echo "			save_env --file \${GRUBENV} EOS_BAK"													>> $GRUBCFG 
	echo "			save_env --file \${GRUBENV} DEFAULT"													>> $GRUBCFG 
	echo "		fi"																							>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "		save_env --file \${GRUBENV} BC"																>> $GRUBCFG 
	echo "	fi"																								>> $GRUBCFG
	echo "else"																								>> $GRUBCFG
	echo "	set DEFAULT=\"0\""																				>> $GRUBCFG
	echo "	save_env --file \${GRUBENV} DEFAULT"															>> $GRUBCFG 
	echo "	set BC=\"0\""																					>> $GRUBCFG
	echo "	save_env --file \${GRUBENV} BC"																	>> $GRUBCFG 
	echo "	set DEFAULT_BAK=\"0\""																			>> $GRUBCFG
	echo "	save_env --file \${GRUBENV} DEFAULT_BAK"														>> $GRUBCFG 
	echo "	set EOS_BAK=\"0\""																				>> $GRUBCFG
	echo "	save_env --file \${GRUBENV} EOS_BAK"															>> $GRUBCFG 
	echo "fi"																								>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "set SWAP=\"0\""																					>> $GRUBCFG
	echo "save_env --file \${GRUBENV} SWAP"																	>> $GRUBCFG 
	echo "set EOS=\"0\""																					>> $GRUBCFG
	echo "save_env --file \${GRUBENV} EOS"																	>> $GRUBCFG 
	echo ""																									>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "set default=\"\${DEFAULT}\""																		>> $GRUBCFG
	echo "set timeout=\"2\""																				>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "menuentry \"RECOVER\" {"																			>> $GRUBCFG
	echo "	linux /bzImage-RECOVER root=${PARTUUID3} rootwait rootfstype=${FSTYPE} console=tty1"			>> $GRUBCFG
	echo "}"																								>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "menuentry \"SYS1\" {"																				>> $GRUBCFG
	echo "	linux /bzImage-SYS1 root=${PARTUUID4} rootwait rootfstype=${FSTYPE} console=tty1"				>> $GRUBCFG
	echo "}"																								>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "menuentry \"SYS2\" {"																				>> $GRUBCFG
	echo "	linux /bzImage-SYS2 root=${PARTUUID5} rootwait rootfstype=${FSTYPE} console=tty1"				>> $GRUBCFG
	echo "}"																								>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "menuentry \"chainloader (hd0,1)\" {"																>> $GRUBCFG
	echo "	set root=(hd0,1)"																				>> $GRUBCFG
	echo "	chainloader ($root)/EFI/BOOT/bootx64.efi"														>> $GRUBCFG
	echo "}"																								>> $GRUBCFG
	echo ""																									>> $GRUBCFG
	echo "menuentry \"chainloader (hd1,1)\" {"																>> $GRUBCFG
	echo "	set root=(hd1,1)"																				>> $GRUBCFG
	echo "	chainloader ($root)/EFI/BOOT/bootx64.efi"														>> $GRUBCFG
	echo "}"																								>> $GRUBCFG
	echo ""																									>> $GRUBCFG
}

prepare_partition () { 
	echo "prepare_partition() $3"

	tar -xf ${ROOTFS} -C ${2}
	cp ${2}/boot/bzImage ${1}/bzImage-${3}
	
	# used for sshfs, delete line in final version
	#echo "PermitRootLogin yes" >> ${2}/etc/ssh/sshd_config
}

get_partuuid () {
	local PARTUUID="$(blkid $1)"
	local RETVAL=""
	
	for ITEM in ${PARTUUID}
	do
		ITEM_ID=$(echo ${ITEM} | cut -d'=' -f1)

		if [ "${ITEM_ID}" = "PARTUUID" ]; then
			RETVAL=${ITEM}
		fi
	done
	
	RETVAL="$(echo ${RETVAL} | sed 's/\"//g')"
	echo "${RETVAL}"
}

#########################################
# begin script section
#########################################

DEVICE=$1
ROOTFS=$2

case "${DEVICE}" in
	/dev/*) ISDEV="true" ;;
	*)	  ISDEV="false" ;;
esac

read -p "Confirm to install \"${DEVICE}\" [y/N]: " CONFIRMATION

case "$CONFIRMATION" in
	y) ;;
	*) exit 0;;
esac

#########################################
# create gtp partition table & partitions
#########################################

if [ "$ISDEV" = "false" ]; then
	dd if=/dev/zero of=${DEVICE} bs=1M count=6200 status=progress
else
	/usr/sbin/wipefs --all --force ${DEVICE}
fi

echo "g
n


+50M
t
1
n


+50M
t
2
19
n


+1G
n


+1G
n


+1G
n


+2G
n



w
" | fdisk --wipe always --wipe-partitions always ${DEVICE}

sleep 2
sync

if [ "$ISDEV" = "false" ]; then
	DEVLOOP=$(losetup -f)
	losetup -f ${DEVICE}
	partx -a ${DEVLOOP}
	DEVICE=${DEVLOOP}p
fi

#########################################
# format the partitions
#########################################

mkfs.vfat -F 32 -n BOOT ${DEVICE}1

FSTYPE="ext4"
mke2fs -q -F -t ${FSTYPE} -L RECOVER ${DEVICE}3
mke2fs -q -F -t ${FSTYPE} -L SYS1    ${DEVICE}4
mke2fs -q -F -t ${FSTYPE} -L SYS2    ${DEVICE}5
mke2fs -q -F -t ${FSTYPE} -L UPDATE  ${DEVICE}6
mke2fs -q -F -t ${FSTYPE} -L DATA    ${DEVICE}7


#########################################
# mount partitions
#########################################

LOCALPATH=$(pwd)

umount /mnt
mkdir -p /mnt/part1
mkdir -p /mnt/part3
mkdir -p /mnt/part4
mkdir -p /mnt/part5
mkdir -p /mnt/part7

mount ${DEVICE}1 /mnt/part1
mount ${DEVICE}3 /mnt/part3
mount ${DEVICE}4 /mnt/part4
mount ${DEVICE}5 /mnt/part5
mount ${DEVICE}7 /mnt/part7

#########################################
# setup boot partition
#########################################

echo "bootx64" > /mnt/part1/startup.nsh

cd /mnt/part1
tar -xf ${LOCALPATH}/${ROOTFS} ./boot/EFI/BOOT/bootx64.efi -C /mnt/part1
cd -

mkdir -p /mnt/part1/EFI/BOOT
cp /mnt/part1/boot/EFI/BOOT/bootx64.efi /mnt/part1/EFI/BOOT
rm -rf /mnt/part1/boot

grub-editenv /mnt/part1/EFI/BOOT/grubenv set DEFAULT=1
grub-editenv /mnt/part1/EFI/BOOT/grubenv set BC=0
grub-editenv /mnt/part1/EFI/BOOT/grubenv set EOS=0
grub-editenv /mnt/part1/EFI/BOOT/grubenv set SWAP=0
grub-editenv /mnt/part1/EFI/BOOT/grubenv set DEFAULT_BAK=0
grub-editenv /mnt/part1/EFI/BOOT/grubenv set EOS_BAK=0
edit_grub_cfg /mnt/part1/EFI/BOOT/grub.cfg

#########################################
# setup RECOVER partition
#########################################

prepare_partition /mnt/part1 /mnt/part3 RECOVER

#########################################
# setup SYS1 partition
#########################################

prepare_partition /mnt/part1 /mnt/part4 SYS1

#########################################
# setup home partition
#########################################

USERS_GID=$(grep users /mnt/part4/etc/group | awk -F':' '{ print $3}')
SFC_UID=$(grep sfc /mnt/part4/etc/passwd | awk -F':' '{ print $3}')
WEBUSER_UID=$(grep webuser /mnt/part4/etc/passwd | awk -F':' '{ print $3}')

mkdir -p /mnt/part7/root
mkdir -p /mnt/part7/sfc
mkdir -p /mnt/part7/sfc/Calibration
mkdir -p /mnt/part7/sfc/Configs
echo "sfc" > /mnt/part7/sfc/Configs/hostname
chown -R ${SFC_UID}:${SFC_UID} /mnt/part7/sfc

mkdir -p /mnt/part7/webuser
cp /mnt/part4/opt/RAYLASE/WebInterface/user.config /mnt/part7/webuser
chown -R ${WEBUSER_UID}:${USERS_GID} /mnt/part7/webuser

#########################################
# unmount partitions
#########################################

echo "umounting ..."
umount /mnt/part1
umount /mnt/part3
umount /mnt/part4
umount /mnt/part5
umount /mnt/part7

rm -rf /mnt/*

#########################################

if [ "$ISDEV" = "false" ]; then
	partx -d ${DEVLOOP}
	losetup -d ${DEVLOOP}
	chown ${SUDO_USER}:${SUDO_USER} $1
fi
