#! /bin/sh


INTERFACE="eth0"

if [ "$1" = "hostname" ]; then
	echo $2 > /etc/hostname
else
	###########################################################
	# write it persistent to /etc/network/ifcfg-eth0
	###########################################################

	if [ "$1" = "dhcp" ]; then
		echo "iface $INTERFACE inet dhcp" > /etc/network/ifcfg-$INTERFACE
		echo "udhcpc_opts -F \$(hostname)" >> /etc/network/ifcfg-$INTERFACE
	elif [ "$1" = "static" ]; then
		if [ $# -gt 1 ]; then
			echo "iface $INTERFACE inet static" > /etc/network/ifcfg-$INTERFACE
			echo "  address $2" >> /etc/network/ifcfg-$INTERFACE

			if [ $# -gt 2 ]; then
				echo "  netmask $3" >> /etc/network/ifcfg-$INTERFACE
			
				if [ $# -gt 3 ]; then
					echo "  gateway $4" >> /etc/network/ifcfg-$INTERFACE
				fi
			fi
		fi
	fi
fi
