# !/bin/bash
#
# Update initialization script for SFC
# Copyright (c) RAYLASE GmbH
#

VERSION="V1.0"

export PATH="${PATH:+$PATH:}/usr/sbin:/sbin:/opt/RAYLASE/scripts"

# Variable configuration and function definitions
. upd_functions.sh

# -----------------------------------------------------------------
#
# main function
#
logecho "Update Trigger $VERSION for SFC started"

if [ X`whoami` != "Xroot" ] ; then
	MSG="Update Trigger: must be called as root."
	echo "${MSG}"
	fatal "${MSG}"
fi


DAEMON_PID=$(tac ${LOG_FILE} | grep -i -m 1 "PID of Update Daemon"  | cut -d'=' -f2)
if [[ ( -z "${DAEMON_PID}" ) || ( "${DAEMON_PID}" -le 0 ) ]] ; then
	MSG="Update Trigger: failed to get Update Daemon PID."
	echo "${MSG}"
	fatal "${MSG}"
fi

MSG="Triggering Update Daemon (PID = ${DAEMON_PID})"
echo "${MSG}"
logecho "${MSG}"

kill -s HUP ${DAEMON_PID}



