#!/bin/bash

if [ -z "$SISODIR5" ]; then
	export SISODIR5=/opt/SiliconSoftware/Runtime5.7.0
fi

export PATH=$SISODIR5/bin:$PATH
export LD_LIBRARY_PATH=$SISODIR5/lib:$LD_LIBRARY_PATH

if [ -z "$SISO_GENICAM_ROOT" ]; then
	export GENICAM_ROOT=$SISODIR5/genicam
else
	export GENICAM_ROOT=$SISO_GENICAM_ROOT
fi

if [ -z "$SISO_GENICAM_CACHE_V3_0" ]; then
	export GENICAM_CACHE_V3_0=$SISODIR5/genicam/cache
else
	export GENICAM_CACHE_V3_0=$SISO_GENICAM_CACHE_V3_0
fi

if [ -z "$SISO_GENICAM_LOG_CONFIG_V3_0" ]; then
	export GENICAM_LOG_CONFIG_V3_0=$SISODIR5/genicam/log/config/SisoLogging.properties
else
	export GENICAM_LOG_CONFIG_V3_0=$SISO_GENICAM_LOG_CONFIG_V3_0
fi

if [ "$(uname)" = "Darwin" ]; then
	PLATFORM="Maci64_x64"
	export LD_LIBRARY_PATH=$SISODIR5/lib64:$LD_LIBRARY_PATH
elif [ "$(uname -i)" = "i386" ]; then
	PLATFORM="Linux32_i86"
elif [ "$(uname -i)" = "x86_64" ]; then
	PLATFORM="Linux64_x64"
elif [ "$(uname -m)" = "x86_64" ]; then
	PLATFORM="Linux64_x64"
else
	PLATFORM="Linux32_i86"
fi

export LD_LIBRARY_PATH=$GENICAM_ROOT/bin/${PLATFORM}:$LD_LIBRARY_PATH

if [ "$(uname)" = "Darwin" ]; then
	export DYLD_LIBRARY_PATH=$LD_LIBRARY_PATH
fi

echo "[INFO ] Using SISODIR5=$SISODIR5"
echo "[INFO ] Prepending '$SISODIR5/bin' to PATH"
echo "[INFO ] Prepending '$SISODIR5/lib' to LD_LIBRARY_PATH"
echo "[INFO ] Using GENICAM_ROOT=$GENICAM_ROOT"
echo "[INFO ] Using GENICAM_CACHE_V3_0=$GENICAM_CACHE_V3_0"
echo "[INFO ] Using GENICAM_LOG_CONFIG_V3_0=$GENICAM_LOG_CONFIG_V3_0"
echo "[INFO ] Prepending '$GENICAM_ROOT/bin/${PLATFORM}' to LD_LIBRARY_PATH"
